--- old/usr/src/uts/common/io/aac/aac_ioctl.c	Thu Nov  1 14:48:27 2012
+++ new/usr/src/uts/common/io/aac/aac_ioctl.c	Thu Nov  1 14:48:27 2012
@@ -1,10 +1,11 @@
 /*
- * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
  */
 
 /*
- * Copyright 2005-06 Adaptec, Inc.
- * Copyright (c) 2005-06 Adaptec Inc., Achim Leubner
+ * Copyright (c) 2010-12 PMC-Sierra, Inc.
+ * Copyright (c) 2005-10 Adaptec Inc., Achim Leubner
  * Copyright (c) 2000 Michael Smith
  * Copyright (c) 2001 Scott Long
  * Copyright (c) 2000 BSDi
@@ -31,6 +32,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  */
+#pragma ident	"@(#)aac_ioctl.c	1.9	07/10/30 SMI"
+
 #include <sys/modctl.h>
 #include <sys/conf.h>
 #include <sys/cmn_err.h>
@@ -58,7 +61,7 @@
  * External functions
  */
 extern int aac_sync_mbcommand(struct aac_softstate *, uint32_t, uint32_t,
-    uint32_t, uint32_t, uint32_t, uint32_t *);
+    uint32_t, uint32_t, uint32_t, uint32_t *, uint32_t *);
 extern int aac_cmd_dma_alloc(struct aac_softstate *, struct aac_cmd *,
     struct buf *, int, int (*)(), caddr_t);
 extern void aac_free_dmamap(struct aac_cmd *);
@@ -65,10 +68,6 @@
 extern int aac_do_io(struct aac_softstate *, struct aac_cmd *);
 extern void aac_cmd_fib_copy(struct aac_softstate *, struct aac_cmd *);
 extern void aac_ioctl_complete(struct aac_softstate *, struct aac_cmd *);
-extern int aac_return_aif_wait(struct aac_softstate *, struct aac_fib_context *,
-    struct aac_fib **);
-extern int aac_return_aif(struct aac_softstate *, struct aac_fib_context *,
-    struct aac_fib **);
 
 extern ddi_device_acc_attr_t aac_acc_attr;
 extern int aac_check_dma_handle(ddi_dma_handle_t);
@@ -262,16 +261,13 @@
 	acp->fib_size = fib_size;
 	fibp->Header.Size = LE_16(fib_size);
 
+	AACDB_PRINT_FIB(softs, fibp);
+
 	/* Process FIB */
 	if (fib_command == TakeABreakPt) {
-#ifdef DEBUG
-		if (aac_dbflag_on(softs, AACDB_FLAGS_FIB) &&
-		    (softs->debug_fib_flags & AACDB_FLAGS_FIB_IOCTL))
-			aac_printf(softs, CE_NOTE, "FIB> TakeABreakPt, sz=%d",
-			    fib_size);
-#endif
+		softs->sync_slot_busy = 1;
 		(void) aac_sync_mbcommand(softs, AAC_BREAKPOINT_REQ,
-		    0, 0, 0, 0, NULL);
+		    0, 0, 0, 0, NULL, NULL);
 		fibp->Header.XferState = LE_32(0);
 	} else {
 		ASSERT(!(fib_xfer_state & AAC_FIBSTATE_ASYNC));
@@ -280,9 +276,6 @@
 
 		acp->timeout = AAC_IOCTL_TIMEOUT;
 		acp->aac_cmd_fib = aac_cmd_fib_copy;
-#ifdef DEBUG
-		acp->fib_flags = AACDB_FLAGS_FIB_IOCTL;
-#endif
 		if ((rval = aac_send_fib(softs, acp)) != 0)
 			goto finish;
 	}
@@ -308,45 +301,45 @@
 static int
 aac_open_getadapter_fib(struct aac_softstate *softs, intptr_t arg, int mode)
 {
-	struct aac_fib_context *fibctx_p, *ctx_p;
+	struct aac_fib_context *fibctx, *ctx;
 
 	DBCALLED(softs, 2);
 
-	fibctx_p = kmem_zalloc(sizeof (struct aac_fib_context), KM_NOSLEEP);
-	if (fibctx_p == NULL)
+	fibctx = kmem_zalloc(sizeof (struct aac_fib_context), KM_NOSLEEP);
+	if (fibctx == NULL)
 		return (ENOMEM);
 
 	mutex_enter(&softs->aifq_mutex);
 	/* All elements are already 0, add to queue */
-	if (softs->fibctx_p == NULL) {
-		softs->fibctx_p = fibctx_p;
+	if (softs->fibctx == NULL) {
+		softs->fibctx = fibctx;
 	} else {
-		for (ctx_p = softs->fibctx_p; ctx_p->next; ctx_p = ctx_p->next)
+		for (ctx = softs->fibctx; ctx->next; ctx = ctx->next)
 			;
-		ctx_p->next = fibctx_p;
-		fibctx_p->prev = ctx_p;
+		ctx->next = fibctx;
+		fibctx->prev = ctx;
 	}
 
 	/* Evaluate unique value */
-	fibctx_p->unique = (unsigned long)fibctx_p & 0xfffffffful;
-	ctx_p = softs->fibctx_p;
-	while (ctx_p != fibctx_p) {
-		if (ctx_p->unique == fibctx_p->unique) {
-			fibctx_p->unique++;
-			ctx_p = softs->fibctx_p;
+	fibctx->unique = (unsigned long)fibctx & 0xfffffffful;
+	ctx = softs->fibctx;
+	while (ctx != fibctx) {
+		if (ctx->unique == fibctx->unique) {
+			fibctx->unique++;
+			ctx = softs->fibctx;
 		} else {
-			ctx_p = ctx_p->next;
+			ctx = ctx->next;
 		}
 	}
 
 	/* Set ctx_idx to the oldest AIF */
 	if (softs->aifq_wrap) {
-		fibctx_p->ctx_idx = softs->aifq_idx;
-		fibctx_p->ctx_filled = 1;
+		fibctx->ctx_idx = softs->aifq_idx;
+		fibctx->ctx_filled = 1;
 	}
 	mutex_exit(&softs->aifq_mutex);
 
-	if (ddi_copyout(&fibctx_p->unique, (void *)arg,
+	if (ddi_copyout(&fibctx->unique, (void *)arg,
 	    sizeof (uint32_t), mode) != 0)
 		return (EFAULT);
 
@@ -354,12 +347,30 @@
 }
 
 static int
+aac_return_aif(struct aac_softstate *softs,
+    struct aac_fib_context *ctx, caddr_t uptr, int mode)
+{
+	int current;
+
+	current = ctx->ctx_idx;
+	if (current == softs->aifq_idx && !ctx->ctx_filled)
+		return (EAGAIN); /* Empty */
+	if (ddi_copyout(&softs->aifq[current].d, (void *)uptr,
+	    sizeof (struct aac_fib), mode) != 0)
+		return (EFAULT);
+
+	ctx->ctx_filled = 0;
+	ctx->ctx_idx = (current + 1) % AAC_AIFQ_LENGTH;
+
+	return (0);
+}
+
+static int
 aac_next_getadapter_fib(struct aac_softstate *softs, intptr_t arg, int mode)
 {
 	union aac_get_adapter_fib_align un;
 	struct aac_get_adapter_fib *af = &un.d;
-	struct aac_fib_context *ctx_p;
-	struct aac_fib *fibp;
+	struct aac_fib_context *ctx;
 	int rval;
 
 	DBCALLED(softs, 2);
@@ -368,32 +379,39 @@
 		return (EFAULT);
 
 	mutex_enter(&softs->aifq_mutex);
-	for (ctx_p = softs->fibctx_p; ctx_p; ctx_p = ctx_p->next) {
-		if (af->context == ctx_p->unique)
+	for (ctx = softs->fibctx; ctx; ctx = ctx->next) {
+		if (af->context == ctx->unique)
 			break;
 	}
-	mutex_exit(&softs->aifq_mutex);
-
-	if (ctx_p) {
-		if (af->wait)
-			rval = aac_return_aif_wait(softs, ctx_p, &fibp);
-		else
-			rval = aac_return_aif(softs, ctx_p, &fibp);
-	}
-	else
-		rval = EFAULT;
-
-finish:
-	if (rval == 0) {
-		if (ddi_copyout(fibp,
-#ifdef _LP64
-		    (void *)(uint64_t)af->aif_fib,
+	if (ctx) {
+#ifdef	_LP64
+		rval = aac_return_aif(softs, ctx,
+		    (caddr_t)(uint64_t)af->aif_fib, mode);
 #else
-		    (void *)af->aif_fib,
+		rval = aac_return_aif(softs, ctx,
+		    (caddr_t)af->aif_fib, mode);
 #endif
-		    sizeof (struct aac_fib), mode) != 0)
-			rval = EFAULT;
+		if (rval == EAGAIN && af->wait) {
+			AACDB_PRINT(softs, CE_NOTE,
+			    "aac_next_getadapter_fib(): waiting for AIF");
+			rval = cv_wait_sig(&softs->aifv, &softs->aifq_mutex);
+			if (rval > 0) {
+#ifdef	_LP64
+				rval = aac_return_aif(softs, ctx,
+				    (caddr_t)(uint64_t)af->aif_fib, mode);
+#else
+				rval = aac_return_aif(softs, ctx,
+				    (caddr_t)af->aif_fib, mode);
+#endif
+			} else {
+				rval = EINTR;
+			}
+		}
+	} else {
+		rval = EFAULT;
 	}
+	mutex_exit(&softs->aifq_mutex);
+
 	return (rval);
 }
 
@@ -400,26 +418,26 @@
 static int
 aac_close_getadapter_fib(struct aac_softstate *softs, intptr_t arg)
 {
-	struct aac_fib_context *ctx_p;
+	struct aac_fib_context *ctx;
 
 	DBCALLED(softs, 2);
 
 	mutex_enter(&softs->aifq_mutex);
-	for (ctx_p = softs->fibctx_p; ctx_p; ctx_p = ctx_p->next) {
-		if (ctx_p->unique != (uint32_t)arg)
+	for (ctx = softs->fibctx; ctx; ctx = ctx->next) {
+		if (ctx->unique != (uint32_t)arg)
 			continue;
 
-		if (ctx_p == softs->fibctx_p)
-			softs->fibctx_p = ctx_p->next;
+		if (ctx == softs->fibctx)
+			softs->fibctx = ctx->next;
 		else
-			ctx_p->prev->next = ctx_p->next;
-		if (ctx_p->next)
-			ctx_p->next->prev = ctx_p->prev;
+			ctx->prev->next = ctx->next;
+		if (ctx->next)
+			ctx->next->prev = ctx->prev;
 		break;
 	}
 	mutex_exit(&softs->aifq_mutex);
-	if (ctx_p)
-		kmem_free(ctx_p, sizeof (struct aac_fib_context));
+	if (ctx)
+		kmem_free(ctx, sizeof (struct aac_fib_context));
 
 	return (0);
 }
@@ -499,24 +517,23 @@
 	}
 	for (usge = usgt; usge < &usgt[srb_sgcount]; usge++) {
 		if (sg64) {
-			struct aac_sg_entry64 *sg64p =
-			    (struct aac_sg_entry64 *)srb->sg.SgEntry;
-
-			usge->bcount = sg64p->SgByteCount;
+			usge->bcount = ((struct aac_sg_entry64 *)srb-> \
+			    sg.SgEntry)->SgByteCount;
 			usge->addr = (caddr_t)
 #ifndef _LP64
-			    (uint32_t)
+			    (uint32_t)((struct aac_sg_entry64 *) \
+			    srb->sg.SgEntry)->SgAddress;
+#else
+			    ((struct aac_sg_entry64 *) \
+			    srb->sg.SgEntry)->SgAddress;
 #endif
-			    sg64p->SgAddress;
 		} else {
-			struct aac_sg_entry *sgp = srb->sg.SgEntry;
-
-			usge->bcount = sgp->SgByteCount;
+			usge->bcount = srb->sg.SgEntry->SgByteCount;
 			usge->addr = (caddr_t)
 #ifdef _LP64
 			    (uint64_t)
 #endif
-			    sgp->SgAddress;
+			    srb->sg.SgEntry->SgAddress;
 		}
 		acp->bcount += usge->bcount;
 		if (usge->addr < addrlo)
@@ -554,12 +571,11 @@
 	for (usge = usgt; usge < &usgt[srb_sgcount]; usge++) {
 		struct buf *bp;
 
-		bp = ddi_umem_iosetup(cookie, (uintptr_t)usge->addr - \
-		    (uintptr_t)addrlo, usge->bcount, direct, dev, 0, NULL,
-		    DDI_UMEM_NOSLEEP);
+		bp = ddi_umem_iosetup(cookie, usge->addr - addrlo,
+		    usge->bcount, direct, dev, 0, NULL, DDI_UMEM_SLEEP);
 		if (bp == NULL) {
 			AACDB_PRINT(softs, CE_NOTE, "ddi_umem_iosetup failed");
-			rval = ENOMEM;
+			rval = EFAULT;
 			goto finish;
 		}
 		if (aac_cmd_dma_alloc(softs, &usge->acp, bp, 0, NULL_FUNC,
@@ -595,10 +611,8 @@
 	acp->timeout = srb->timeout;
 
 	/* Send FIB command */
+	AACDB_PRINT_FIB(softs, fibp);
 	acp->aac_cmd_fib = softs->aac_cmd_fib_scsi;
-#ifdef DEBUG
-	acp->fib_flags = AACDB_FLAGS_FIB_SRB;
-#endif
 	if ((rval = aac_send_fib(softs, acp)) != 0)
 		goto finish;
 
@@ -640,23 +654,20 @@
 {
 	union aac_pci_info_align un;
 	struct aac_pci_info *resp = &un.d;
-	pci_regspec_t *pci_rp;
-	uint_t num;
+	int val;
+	int *props;
+	unsigned int numProps;
 
 	DBCALLED(softs, 2);
 
-	if (ddi_prop_lookup_int_array(DDI_DEV_T_ANY, softs->devinfo_p,
-	    DDI_PROP_DONTPASS, "reg", (int **)&pci_rp, &num) !=
-	    DDI_PROP_SUCCESS)
-		return (EINVAL);
-	if (num < (sizeof (pci_regspec_t) / sizeof (int))) {
-		ddi_prop_free(pci_rp);
-		return (EINVAL);
-	}
+	val = ddi_prop_lookup_int_array(DDI_DEV_T_ANY,
+		softs->devinfo_p, 0, "reg", &props, &numProps);
+	if (val != DDI_PROP_SUCCESS || numProps == 0)
+		return (EFAULT);
 
-	resp->bus = PCI_REG_BUS_G(pci_rp->pci_phys_hi);
-	resp->slot = PCI_REG_DEV_G(pci_rp->pci_phys_hi);
-	ddi_prop_free(pci_rp);
+	resp->bus = PCI_REG_BUS_G(props[0]);
+	resp->slot = PCI_REG_DEV_G(props[0]);
+	ddi_prop_free(props);
 
 	if (ddi_copyout(resp, (void *)arg,
 	    sizeof (struct aac_pci_info), mode) != 0)
@@ -691,7 +702,7 @@
 
 	mutex_enter(&softs->io_lock);
 	dvp = &softs->containers[qdisk->container_no];
-	qdisk->valid = AAC_DEV_IS_VALID(&dvp->dev);
+	qdisk->valid = dvp->dev.valid;
 	qdisk->locked = dvp->locked;
 	qdisk->deleted = dvp->deleted;
 	mutex_exit(&softs->io_lock);
@@ -724,7 +735,7 @@
 	 * a container, rather we rely on an AIF coming from the
 	 * controller.
 	 */
-	if (AAC_DEV_IS_VALID(&dvp->dev)) {
+	if (dvp->dev.valid) {
 		if (dvp->locked)
 			rval = EBUSY;
 	}
@@ -762,16 +773,12 @@
 	if (f->feat.fValue == 0) {
 		f->feat.fBits.largeLBA =
 		    (softs->flags & AAC_FLAGS_LBA_64BIT) ? 1 : 0;
-		f->feat.fBits.JBODSupport =
-		    (softs->flags & AAC_FLAGS_JBOD) ? 1 : 0;
+		f->feat.fBits.JBODSupport = 1;
 		/* TODO: In the future, add other features state here as well */
 	} else {
 		if (f->feat.fBits.largeLBA)
 			f->feat.fBits.largeLBA =
 			    (softs->flags & AAC_FLAGS_LBA_64BIT) ? 1 : 0;
-		if (f->feat.fBits.JBODSupport)
-			f->feat.fBits.JBODSupport =
-			    (softs->flags & AAC_FLAGS_JBOD) ? 1 : 0;
 		/* TODO: Add other features state and data in the future */
 	}
 
--- old/usr/src/uts/common/io/aac/aac_ioctl.h	Thu Nov  1 14:48:28 2012
+++ new/usr/src/uts/common/io/aac/aac_ioctl.h	Thu Nov  1 14:48:27 2012
@@ -1,10 +1,11 @@
 /*
- * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
  */
 
 /*
- * Copyright 2005-06 Adaptec, Inc.
- * Copyright (c) 2005-06 Adaptec Inc., Achim Leubner
+ * Copyright (c) 2010-11 PMC-Sierra, Inc.
+ * Copyright (c) 2005-10 Adaptec Inc., Achim Leubner
  * Copyright (c) 2000 Michael Smith
  * Copyright (c) 2000 Scott Long
  * Copyright (c) 2000 BSDi
@@ -30,14 +31,13 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- *    $FreeBSD: /repoman/r/ncvs/src/sys/sys/aac_ioctl.h,
- *    v 1.11 2004/12/09 22:20:25 scottl Exp $
  */
 
 #ifndef	_AAC_IOCTL_H_
 #define	_AAC_IOCTL_H_
 
+#pragma ident	"@(#)aac_ioctl.h	1.3	07/10/30 SMI"
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -83,7 +83,7 @@
 struct aac_get_adapter_fib
 {
 	uint32_t context;
-	int32_t wait;
+	int wait;
 	uint32_t aif_fib;	/* RAID config app is 32bit */
 };
 
@@ -116,9 +116,9 @@
 typedef union {
 	struct {
 		uint32_t largeLBA  : 1;	/* disk support greater 2TB */
-		uint32_t IoctlBuf  : 1; /* ARCIOCTL call support */
-		uint32_t AIFSupport: 1; /* AIF support */
-		uint32_t JBODSupport:1; /* firmware+driver both support JBOD */
+		uint32_t IoctlBuf  : 1;	/* ARCIOCTL call support */
+		uint32_t AIFSupport: 1;	/* AIF support */
+		uint32_t JBODSupport:1;	/* firmware + driver both support JBOD */
 		uint32_t fReserved : 28;
 	} fBits;
 	uint32_t fValue;
@@ -138,7 +138,7 @@
  *
  * Normally the packed structures are defined in a way that if the initial
  * member is aligned, then the following members will also be aligned. So
- * we need only to make sure the packed structure, ie. the first member, is
+ * we need only to make the packed structure, ie. the first member, is
  * aligned to satisfy alignment requirement.
  */
 union aac_revision_align {
--- old/usr/src/uts/common/io/aac/aac_regs.h	Thu Nov  1 14:48:28 2012
+++ new/usr/src/uts/common/io/aac/aac_regs.h	Thu Nov  1 14:48:28 2012
@@ -1,10 +1,11 @@
 /*
- * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
  */
 
 /*
- * Copyright 2005-06 Adaptec, Inc.
- * Copyright (c) 2005-06 Adaptec Inc., Achim Leubner
+ * Copyright (c) 2010-12 PMC-Sierra, Inc.
+ * Copyright (c) 2005-10 Adaptec Inc., Achim Leubner
  * Copyright (c) 2000 Michael Smith
  * Copyright (c) 2000-2001 Scott Long
  * Copyright (c) 2000 BSDi
@@ -30,13 +31,13 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- *    $FreeBSD: src/sys/dev/aac/aacreg.h,v 1.23 2005/10/14 16:22:45 scottl Exp $
  */
 
 #ifndef	__AAC_REGS_H__
 #define	__AAC_REGS_H__
 
+#pragma ident	"@(#)aac_regs.h	1.12	08/01/29 SMI"
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -52,9 +53,14 @@
 #define	AAC_DB_RESPONSE_NOT_FULL	(1<<4)	/* response queue not full */
 #define	AAC_DB_PRINTF_READY		(1<<5)	/* adapter requests host */
 						/* printf */
+#define AAC_DB_AIF_PENDING		(1<<6)	/* pending AIF (new comm. type1) */
+/* PMC specific outbound doorbell bits */
+#define AAC_DB_RESPONSE_SENT_NS		(1<<1)	/* response sent (not shifted) */
+
 #define	AAC_DB_INTR_BITS (AAC_DB_COMMAND_READY | \
 	AAC_DB_RESPONSE_READY | AAC_DB_PRINTF_READY)
 #define	AAC_DB_INTR_NEW			0x08
+#define	AAC_DB_INTR_NEW_TYPE1	0x04
 
 /* Status bits in firmware status reg */
 #define	AAC_SELF_TEST_FAILED		0x00000004
@@ -76,6 +82,28 @@
 #define	AAC_RKT_MAILBOX		0x1000	/* mailbox, size=20bytes, rkt */
 #define	AAC_RKT_FWSTATUS	0x101c	/* firmware status, rkt */
 
+/*
+ * Register definitions for the Adaptec PMC SRC adapters.
+ */
+/* accessible via BAR0 */
+#define AAC_SRC_OMR			0xbc	/* outbound message register */
+#define AAC_SRC_IDBR		0x20	/* inbound doorbell register */
+#define AAC_SRC_IISR		0x24	/* inbound interrupt status register */
+#define AAC_SRC_ODBR_R		0x9c	/* outbound doorbell register read */
+#define AAC_SRC_ODBR_C		0xa0	/* outbound doorbell register clear */
+#define AAC_SRC_OIMR		0x34	/* outbound interrupt mask register */
+#define AAC_SRC_IQUE32		0x40	/* inbound queue address 32-bit */
+#define AAC_SRC_IQUE64_L	0xc0	/* inbound queue address 64-bit (low) */
+#define AAC_SRC_IQUE64_H	0xc4	/* inbound queue address 64-bit (high) */
+
+#define AAC_SRC_MAILBOX		0x7fc60	/* mailbox (20 bytes) */
+#define AAC_SRCV_MAILBOX	0x1000	/* mailbox (20 bytes) */
+
+#define AAC_SRC_ODR_SHIFT 	12		/* outbound doorbell shift */
+#define AAC_SRC_IDR_SHIFT 	9		/* inbound doorbell shift */
+
+#define	AAC_MAX_MEM_SPACE	3	/* max number of PCI mem spaces */
+
 /* Synchronous commands to the monitor/kernel. */
 #define	AAC_BREAKPOINT_REQ	0x04
 #define	AAC_MONKER_INITSTRUCT	0x05
@@ -85,6 +113,7 @@
 #define	AAC_MONKER_GETDRVPROP	0x23
 #define	AAC_MONKER_GETCOMMPREF	0x26
 #define	AAC_IOP_RESET		0x1000
+#define	AAC_IOP_RESET_ALWAYS	0x1001
 
 /* Sunrise Lake dual core reset */
 #define	AAC_IRCSR_CORES_RST	3
@@ -114,6 +143,10 @@
  */
 #define	AAC_MAP_SIZE_MIN_RX	4096
 #define	AAC_MAP_SIZE_MIN_RKT	8192
+#define AAC_MAP_SIZE_MIN_SRC_BAR0	0x400000
+#define AAC_MAP_SIZE_MIN_SRC_BAR1	0x800
+#define AAC_MAP_SIZE_MIN_SRCV_BAR0	0x100000
+#define AAC_MAP_SIZE_MIN_SRCV_BAR1	0x400
 
 /*
  * Options supported by the adapter
@@ -137,21 +170,36 @@
 #define	AAC_SUPPORTED_NEW_COMM			0x20000
 #define	AAC_SUPPORTED_64BIT_ARRAYSIZE		0x40000
 #define	AAC_SUPPORTED_HEAT_SENSOR		0x80000
+#define AAC_SUPPORTED_NEW_COMM_TYPE1	0x10000000  /* Tupelo new comm */
+#define AAC_SUPPORTED_NEW_COMM_TYPE2	0x20000000  /* Denali new comm */
+#define AAC_SUPPORTED_NEW_COMM_TYPE3	0x40000000  /* Series 8 new comm */
+#define AAC_SUPPORTED_NEW_COMM_TYPE4	0x80000000  /* Series 9 new comm */
 
 /*
  * More options from supplement info - SupportedOptions2
  */
-#define	AAC_SUPPORTED_MU_RESET			0x01
-#define	AAC_SUPPORTED_IGNORE_RESET		0x02
-#define	AAC_SUPPORTED_POWER_MANAGEMENT		0x04
-#define	AAC_SUPPORTED_ARCIO_PHYDEV		0x08
+#define AAC_SUPPORTED_MU_RESET			0x01
+#define AAC_SUPPORTED_IGNORE_RESET		0x02
+#define AAC_SUPPORTED_POWER_MANAGEMENT		0x04
+#define AAC_SUPPORTED_ARCIO_PHYDEV		0x08
+#define AAC_SUPPORTED_DOORBELL_RESET		0x4000
+
+
 /*
  * FeatureBits of RequestSupplementAdapterInfo used in the driver
  */
-#define	AAC_FEATURE_SUPPORTED_JBOD		0x08000000
+#define AAC_SUPPL_SUPPORTED_JBOD	0x08000000
 
 #pragma	pack(1)
 
+/* transport FIB header (PMC) */
+struct aac_fib_xporthdr {
+	uint64_t	HostAddress;	/* FIB host address w/o xport header */
+	uint32_t	Size;			/* FIB size excluding xport header */
+	uint32_t	Handle;			/* driver handle to reference the FIB */
+	uint64_t	Reserved[2];
+};
+
 /*
  * FIB (FSA Interface Block) this is the data structure passed between
  * the host and adapter.
@@ -160,14 +208,18 @@
 	uint32_t	XferState;
 	uint16_t	Command;
 	uint8_t		StructType;
-	uint8_t		Flags;
+	uint8_t		Unused;
 	uint16_t	Size;
 	uint16_t	SenderSize;
 	uint32_t	SenderFibAddress;
-	uint32_t	ReceiverFibAddress;
-	uint32_t	SenderData;
-	int prev;
-	int next;
+	union {
+		uint32_t	ReceiverFibAddress;
+		uint32_t	SenderFibAddressHigh;
+		uint32_t	TimeStamp;
+	} a;
+	uint32_t	Handle;
+	uint32_t	Previous;
+	uint32_t	Next;
 };
 
 /* FIB completed without error or no data was transferred in the FIB */
@@ -197,9 +249,12 @@
 #define	AAC_FIBSTATE_NORM		(1<<12)	/* normal priority */
 #define	AAC_FIBSTATE_ASYNC		(1<<13)
 #define	AAC_FIBSTATE_FAST_RESPONSE	(1<<19)	/* fast response capable */
+#define AAC_FIBSTATE_NOMOREAIF		(1<<21)
 
 /* FIB types */
 #define	AAC_FIBTYPE_TFIB		1
+#define	AAC_FIBTYPE_TFIB2		4
+#define	AAC_FIBTYPE_TFIB2_64	5
 
 /*
  * FIB commands
@@ -237,6 +292,7 @@
 #define	ContainerCommand		500
 #define	ContainerCommand64		501
 #define	RawIo				502
+#define	RawIo2				503
 /* Cluster commands */
 #define	ClusterCommand			550
 /* Scsi Port commands (scsi passthrough) */
@@ -341,9 +397,9 @@
 	/* PCBA serial no. from th MFG sector */
 	uint8_t		MfgPcbaSerialNo[MFG_PCBA_SERIAL_NUMBER_WIDTH];
 	/* WWN from the MFG sector */
-	uint8_t		MfgWWNName[MFG_WWN_WIDTH];
-	uint32_t	SupportedOptions2;	/* more supported features */
-	uint32_t	ExpansionFlag;	/* 1 - following fields are valid */
+	uint8_t		MfgWWNName[MFG_WWN_WIDTH];  
+	uint32_t	SupportedOptions2;		/* more supported features */
+	uint32_t	ExpansionFlag;			/* 1 - following fields are valid */
 	uint32_t	FeatureBits3;
 	uint32_t	SupportedPerformanceMode;
 	/* Growth Area for future expansion */
@@ -364,6 +420,12 @@
 	uint64_t	ViaAdapterSerialNumber;
 };
 
+/* Flag values for ContentState */
+#define AAC_FSCS_NOTCLEAN	0x1	/* fscheck is necessary before mounting */
+#define AAC_FSCS_READONLY	0x2	/* possible result of broken mirror */
+#define AAC_FSCS_HIDDEN		0x4	/* container should be ignored by driver */
+#define AAC_FSCS_NOT_READY	0x8	/* cnt is in spinn. state, not rdy for IO's */
+
 struct aac_mntobj {
 	uint32_t		ObjectId;
 	char			FileSystemName[16];
@@ -689,9 +751,66 @@
 	/* 210 added to support firmware cache sync operations */
 	CT_GET_CACHE_SYNC_INFO,
 	CT_SET_CACHE_SYNC_MODE,		/* 211 */
-	CT_PM_DRIVER_SUPPORT,		/* 212 */
-	CT_PM_CONFIGURATION,		/* 213 */
+	CT_GET_PARTITION_TABLE_500,	
+	CT_GET_PARTITION_INFO_500,
+	CT_GET_DISK_PARTITIONS_500,
 
+	CT_GET_RAID_CONFIG,			/* 215 */
+	CT_COPYBACK_ENABLE,
+	CT_CONTAINER_OPTIONS_500,
+
+	CT_MARK_BAD_STRIPES,		/* 218 */
+
+	CT_GET_RAID6_OPTIONS_500,	/* 219 */
+
+	CT_GET_SS_MAP_INFO,			/* 220 */
+
+	CT_CREATE_CONTAINER_64,		/* 221 */
+	CT_COPY_STATUS_64, 
+	CT_GET_SNAPSHOT_INFO_64,
+
+	CT_ENABLE_RAID_ENHANCED,	/* 224 */
+	
+	CT_GET_CONTAINER_SPITFIRE_SIZE,	/* 225 */
+	CT_STAMP_SPITFIRE_VM,
+
+	CT_GET_BST_INFO,			/* 227 */
+	CT_ERASE_BAD_STRIPE_TABLE,
+
+	CT_GET_CONTAINER_LIST,		/* 229 */
+										
+	CT_FREE_FOR_USE,			/* 230 */
+
+	CT_GET_HIST_LOG_SIZE,		/* 231 */
+	CT_GET_HIST_LOG_ENTRY,		
+
+	CT_CONTINUE_DATA_STOP,		/* 233 */
+
+	CT_GET_LOGDEV_INFO,			/* 234 */
+	CT_GET_LOGDEV_SEGMENT_LIST,
+
+	CT_SET_MINIARC_HOST_MEMORY_SEGMENTS,	/* 236 */
+
+	CT_CREATE_LOGICAL_DRIVE,	/* 237 */
+
+	CT_SET_CONTROLLER_DEVICE_CACHE_POLICY,	/* 238 */
+	CT_GET_CONTROLLER_DEVICE_CACHE_POLICY, 
+
+	CT_GET_MISC_STATUS_V3,		/* 240 */
+
+	CT_IDENTIFY_DEVICE,			/* 241 */
+
+	CT_CREATE_JBOD,				/* 242 */
+	CT_DELETE_JBOD,
+
+	CT_GET_STATISTIC_DATA,		/* 244 */
+
+	CT_PM_DRIVER_SUPPORT,		/* 245 */
+	CT_PM_CONFIGURATION,
+	CT_GET_PHYDEV_LIST,
+	CT_GET_PHYDEV_INFO,
+	CT_GET_LOGDEV_SEGMENT64_LIST,
+
 	CT_LAST_COMMAND			/* last command */
 } AAC_CTCommand;
 
@@ -705,6 +824,7 @@
 	AAC_PM_DRIVERSUP_STOP_UNIT
 } AAC_CT_PM_DRIVER_SUPPORT_SUB_COM;
 
+
 struct aac_fsa_ctm {
 	uint32_t	command;
 	uint32_t	param[CT_FIB_PARAMS];
@@ -816,6 +936,7 @@
 	ST_DQUOT = 69,
 	ST_STALE = 70,
 	ST_REMOTE = 71,
+	ST_NOT_READY = 72,
 	ST_BADHANDLE = 10001,
 	ST_NOT_SYNC = 10002,
 	ST_BAD_COOKIE = 10003,
@@ -900,6 +1021,13 @@
 	uint32_t	Flags;		/* reserved */
 };
 
+struct aac_sge_ieee1212 {
+	uint32_t	addrLow;
+	uint32_t	addrHigh;
+	uint32_t	length;
+	uint32_t	flags;		/* reserved */
+};
+
 struct aac_sg_table {
 	uint32_t		SgCount;
 	struct aac_sg_entry	SgEntry[1]; /* at least there is one */
@@ -978,6 +1106,34 @@
 	struct aac_sg_tableraw	SgMapRaw;
 };
 
+#define RIO2_IO_TYPE		0x0003
+#define RIO2_IO_TYPE_WRITE	0x0000
+#define RIO2_IO_TYPE_READ	0x0001
+#define RIO2_IO_TYPE_VERIFY	0x0002
+#define RIO2_IO_ERROR		0x0004
+#define RIO2_IO_SUREWRITE	0x0008
+#define RIO2_SGL_CONFORMANT	0x0010
+#define RIO2_SG_FORMAT		0xF000
+#define RIO2_SG_FORMAT_ARC	0x0000
+#define RIO2_SG_FORMAT_SRL	0x1000
+#define RIO2_SG_FORMAT_IEEE1212	0x2000
+
+struct aac_raw_io2 {
+	uint32_t		strtBlkLow;
+	uint32_t		strtBlkHigh;
+	uint32_t		byteCnt;
+	uint16_t		ldNum;
+	uint16_t		flags;			/* RIO2_xxx */
+	uint32_t		sgeFirstSize;	/* size of first S/G el. */
+	uint32_t		sgeNominalSize;	/* size of 2nd S/G el. */
+	uint8_t			sgeCnt;
+	uint8_t			bpTotal;		/* following elements reserved */
+	uint8_t			bpComplete;
+	uint8_t			sgeFirstIndex;
+	uint8_t			unused[4];
+	struct aac_sge_ieee1212	sge[1];	/* S/G list */
+};
+
 /*
  * Container shutdown command.
  */
@@ -1016,12 +1172,15 @@
 
 #define	AAC_INIT_STRUCT_REVISION		3
 #define	AAC_INIT_STRUCT_REVISION_4		4
+#define AAC_INIT_STRUCT_REVISION_6		6
+#define AAC_INIT_STRUCT_REVISION_7		7
 #define	AAC_INIT_STRUCT_MINIPORT_REVISION	1
-
 #define	AAC_INIT_FLAGS_NEW_COMM_SUPPORTED	1
-#define	AAC_INIT_FLAGS_DRIVER_USES_UTC_TIME	0x10
-#define	AAC_INIT_FLAGS_DRIVER_SUPPORTS_PM	0x20
-
+#define AAC_INIT_FLAGS_DRIVER_USES_UTC_TIME	0x10
+#define AAC_INIT_FLAGS_DRIVER_SUPPORTS_PM	0x20
+#define AAC_INITFLAGS_NEW_COMM_TYPE1_SUPPORTED  0x40
+#define AAC_INITFLAGS_DRIVER_SUPPORTS_FAST_JBOD  0x80
+#define AAC_INITFLAGS_NEW_COMM_TYPE2_SUPPORTED  0x100
 #define	AAC_PAGE_SIZE				4096
 struct aac_adapter_init {
 	uint32_t	InitStructRevision;
@@ -1042,6 +1201,11 @@
 	uint32_t	MaxIoCommands;
 	uint32_t	MaxIoSize;
 	uint32_t	MaxFibSize;
+	/* ADAPTER_INIT_STRUCT_REVISION_5 begins here */
+	uint32_t	MaxNumAif;	        /* max number of aif */ 
+	/* ADAPTER_INIT_STRUCT_REVISION_6 begins here */
+	uint32_t	HostRRQ_AddrLow;
+	uint32_t	HostRRQ_AddrHigh;	/* Host RRQ (response queue) for SRC */
 };
 
 /* ************AAC QUEUE DEFINES (BELOW)*********** */
@@ -1254,20 +1418,31 @@
 	AifEnConfigResume,	/* Container resume event */
 	AifEnFailoverChange,	/* Failover space assignment changed */
 	AifEnRAID5RebuildDone,	/* RAID5 rebuild finished */
-	AifEnEnclosureManagement,	/* Enclosure management event */
+	AifEnEnclosureManagement, /* Enclosure management event */
 	AifEnBatteryEvent,	/* Significant NV battery event */
 	AifEnAddContainer,	/* A new container was created. */
 	AifEnDeleteContainer,	/* A container was deleted. */
 	AifEnSMARTEvent,	/* SMART Event */
-	AifEnBatteryNeedsRecond,	/* The battery needs reconditioning */
-	AifEnClusterEvent,		/* Some cluster event */
-	AifEnDiskSetEvent,		/* A disk set event occured. */
-	AifEnAddJBOD = 30,	/* A new JBOD type drive was created (30) */
-	AifEnDeleteJBOD = 31,	/* A JBOD type drive was deleted (31) */
-	AifDriverNotifyStart = 199,	/* Notifies for host driver go here */
+	AifEnBatteryNeedsRecond, /* The battery needs reconditioning */
+	AifEnClusterEvent,	/* Some cluster event */
+	AifEnDiskSetEvent,	/* A disk set event occured. */
+	AifEnContainerScsiEvent, /* a container event with no. and scsi id */
+	AifEnPicBatteryEvent,	/* An event gen. by pic_battery.c for an ABM */
+	AifEnExpEvent,		/* Exp. Event Type to replace CTPopUp mess. */
+	AifEnRAID6RebuildDone,	/* RAID6 rebuild finished */
+	AifEnSensorOverHeat,	/* Heat Sensor indicate overheat */
+	AifEnSensorCoolDown,	/* Heat Sensor ind. cooled down after overheat*/
+	AifFeatureKeysModified,	/* notif. of updated feature keys */
+	AifApplicationExpirationEvent,	/* notif. on app. expiration status */
+	AifEnBackgroundConsistencyCheck, /* BCC notif. for NEC - DDTS 94700 */
+	AifEnAddJBOD,		/* A new JBOD type drive was created (30) */
+	AifEnDeleteJBOD,	/* A JBOD type drive was deleted (31) */
+	AifDriverNotifyStart = 199, /* Notifies for host driver go here */
 	/* Host driver notifications start here */
-	AifDenMorphComplete,		/* A morph operation completed */
-	AifDenVolumeExtendComplete	/* Volume expand operation completed */
+	AifDenMorphComplete,	/* A morph operation completed */
+	AifDenVolumeExtendComplete, /* Volume expand operation completed */
+	AifDriverNotifyDelay,
+	AifRawDeviceRemove			/* Raw device Failure event */
 } AAC_AifEventNotifyType;
 
 struct aac_AifEnsGeneric {
@@ -1365,7 +1540,8 @@
 	AifReqSendAPIReport,	/* API generic report requests */
 	AifReqAPIJobStart,	/* Start a job from the API */
 	AifReqAPIJobUpdate,	/* Update a job report from the API */
-	AifReqAPIJobFinish	/* Finish a job from the API */
+	AifReqAPIJobFinish,	/* Finish a job from the API */
+	AifReqEvent = 200	/* PMC NEW COMM: Request the event data */
 } AAC_AifCommand;
 
 struct aac_aif_command {
@@ -1534,7 +1710,8 @@
 	uint32_t scsi_status;
 	uint32_t data_xfer_length;
 	uint32_t sense_data_size;
-	uint8_t sense_data[AAC_SENSE_BUFFERSIZE];
+	uint8_t sense_data[AAC_SENSE_BUFFERSIZE];    /* Can this be */
+						    /* SCSI_SENSE_BUFFERSIZE */
 };
 
 /*
@@ -1624,6 +1801,8 @@
 	struct aac_queue_table qtable;
 	char qt_align_pad[AAC_QUEUE_ALIGN];
 	char adapter_print_buf[AAC_ADAPTER_PRINT_BUFSIZE];
+    /* response buffer for SRC (new comm. type1) - must be last element */
+    uint32_t aac_host_rrq[1];
 };
 
 #ifdef	__cplusplus
